--level can be 17x30 onscreen
--level is = 15x28 (8px border) & 16px for stats
--NOTE: 1 block is 16 pixel

--w=75,h=59,2
style = "ice"
Level={background="bg_field2.png"}
--load style at levelload!
if style=="" or style=="default" then
	gfxstyle = "gfx_park_tiles.png"
else
	gfxstyle = "gfx".."_"..style.."_tiles.png"
	file = io.open(gfxstyle, "r")
	io.close() -- cleanup
  if not file then
  	gfxstyle="gfx_park_tiles.png"
  end
end


--load images
images={
	gfx_bombs = Image.load("gfx_bombs.png"), --192x32
	gfx_tiles = Image.load(gfxstyle),
	gfx_p1 = Image.load("gfx_p1.png"),
	gfx_p2 = Image.load("gfx_p2.png"),
	level_border = Image.load("level_border.png")
}
--load sounds
snd_explode = Sound.load('snd_explode.wav', false) --do not loop
snd_laybomb = Sound.load('snd_laybomb.wav', false) --do not loop

--offscreen layers
layer = {
	background = Image.load(Level.background),
	map = Image.createEmpty(480, 272),
	backpuffer = Image.createEmpty(480, 272),
	explode = Image.createEmpty(480, 272)
	}

--bombsOnMap = {}

--globals
maxSpeed = 10
score = 0
high = 0
movement = {p1={dx=0,dy=0,speedx=1,speedy=1},p2={dx=0,dy=0,speedx=1,speedy=1}}
--index for animated tiles
framecount = 0
singleplayer = false

gameOver = 'false'


--possible directions
down = 1
up = 2
right = 3
left = 4
--										down, up, right, left
check_coordinates = {
	{{0,	16},{16,16}}, --down --> bottom_left, bottom_right
	{{0,	0},	{16,0}}, 	--up --> bottom_left, bottom_right
	{{16,	0},	{16,16}}, --right --> bottom_left, bottom_right
	{{0,	0},	{0,	16}} 		--left --> bottom_left, bottom_right
	}
check_tiles = {
	{0,	1}, --down --> bottom_left, bottom_right
	{0,	-1}, 	--up --> bottom_left, bottom_right
	{1,	0}, --right --> bottom_left, bottom_right
	{-1,0} 		--left --> bottom_left, bottom_right
	}


--define tiles (width and height is always 16)
	tile = {
		grass = { x = 0, y = 0, cycle=8 },
		solid = { x = 0, y = 16, cycle=8 },
		wall = { x = 0, y = 32, cycle=8 },
		breakingWall = {x=0,y=48,cycle=8},
		bomb = { x = 0, y = 0, cycle=8 },
		bombexplode = { x = 0, y = 16, cycle=8 }, 
	}
	tile_p1_down = { x = 0, y = down*24-24, cycle=8 } 	--animated tile
	tile_p1_up = { x = 0, y = up*24-24, cycle=8 } 			--animated tile
	tile_p1_right = { x = 0, y = right*24-24, cycle=8 }	--animated tile
	tile_p1_left = { x = 0, y = left*24-24, cycle=8 }		--animated tile

	tile_p2_down = { x = 0, y = down*24-24, cycle=8 } 	--animated tile
	tile_p2_up = { x = 0, y = up*24-24, cycle=8 } 			--animated tile
	tile_p2_right = { x = 0, y = right*24-24, cycle=8 }	--animated tile
	tile_p2_left = { x = 0, y = left*24-24, cycle=8 }		--animated tile
	
tile_p1 = {tile_p1_down, tile_p1_up, tile_p1_right, tile_p1_left}
tile_p2 = {tile_p2_down, tile_p2_up, tile_p2_right, tile_p2_left}

--item-IDS_
--p1 = player 1 start
--p2 = player 2 start
--0 = empty
--1 = solid
--2 = bombable
--11 = p1-bomb
--12 = p2-bomb


--if Level.version == 0 then -- no level loaded yet!
--	selectedScheme='basic.sch'
--	dofile('loadlevel.lua')
--end

--print(Level.x)
--Level.data --definition 15x29
Level ={
	x=8, --always this value
	y=24, --always this value
	usebackground=false,
	background="bg_field2.png",
	style = "ice",
	data= {
		{0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{2,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0}
	}
}

Startpos = {
	p1 = {x=1,y=1},
	p2 = {x=29,y=15}
}

LEVEL_TYPE = 'TIME'

--print(Startpos.p1.x)

GameType = {
	TimePoints = {title='TimePoints', time=2, value=0 }, --in minutes
	TimeKills = {title='TimeKills', time=2, value=0 }, --in minutes
	Points = {title='Points', time=0, value=10},
	Kills = {title='Kills', time=0, value=10}
}
--define player data
--NOTE playerx&y is the pos where it will be started to draw!
-- the actual standing pos is x+8; y+21
player = {
	p1={
		x=Level.x+Startpos.p1.x*16-16, --the pos where the image starts --+8,+21 <-- the pos where bomberman actually stands
		y=-14+Startpos.p1.y*16-16,
		posx = Level.x+Startpos.p2.x*16-16,
		posy = -14+Startpos.p2.x*16-16,
		direction=down,
		lastdirection=down,
		speed=5,
		tilex=Startpos.p1.x,
		tiley=Startpos.p1.y,
		flamelength=3,
		hasbombs=3,
		bombs={
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0}},
		visible=true,
		undestroyable=false,
		kills=0,
		deaths=0,
		suicide=0,
		freeze=0
	},
	p2={
		x=Level.x+28*16, --the pos where the image starts --+8,+21 <-- the pos where bomberman actually stands
		y=Level.y+13*16-22,
		posx = Level.x+Startpos.p2.x*16-16,
		posy = -14+Startpos.p2.x*16-16,
		direction=up,
		lastdirection=up,
		speed=5,
		tilex=Startpos.p2.x,
		tiley=Startpos.p2.y,
		flamelength=3,
		hasbombs=3,
		bombs={
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},{time=60,x=0,y=0,active=false,placed=false,frame=0},
			{time=60,x=0,y=0,active=false,placed=false,frame=0}},
		visible=true,
		undestroyable=false,
		kills=0,
		deaths=0,
		suicide=0,
		freeze=0
	}
	--add player2 here when we are done with player1
}
--highscorefile
highscoreFile = "highscore.txt"

function transposeMatrix(matrix)
	newMatrix = {}
	for i = 1,table.getn(matrix[1]) do  --1..17
		table.insert( newMatrix, {} ) --adds a line
		for j = 1,table.getn(matrix) do	--1..17
			table.insert( newMatrix[i], matrix[j][i] ) --change i|j
		end
	end
	return newMatrix
end

function drawMap()
	layer.map:clear()
	for i=0,table.getn(Level.data)-1 do --15lines
		for j=0,table.getn(Level.data[1])-1 do --29tiles
			if Level.data[i+1][j+1]<0 then --empty; -1 = kill
				--layer.map:fillRect(Level.x+i*16, Level.y+j*16, 16, 16, Color.new(0,0,255))
			elseif Level.data[i+1][j+1]==0 then --empty; -1 = kill
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.grass.x+math.mod(framecount,tile.grass.cycle)*16, tile.grass.y, 16, 16, true)
			elseif Level.data[i+1][j+1] == 1 then--solid
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.grass.x+math.mod(framecount,tile.grass.cycle)*16, tile.grass.y, 16, 16, true)
				-- wall may have some trans-parts so draw the floor below
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.solid.x+math.mod(framecount,tile.solid.cycle)*16, tile.solid.y, 16, 16, true)
			elseif Level.data[i+1][j+1] == 2 then--wall
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.grass.x+math.mod(framecount,tile.grass.cycle)*16, tile.grass.y, 16, 16, true)
				-- wall may have some trans-parts so draw the floor below
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.wall.x+math.mod(framecount,tile.wall.cycle)*16, tile.wall.y, 16, 16, true)				
			else --sprite or player
				layer.map:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.grass.x+math.mod(framecount,tile.grass.cycle)*16, tile.grass.y, 16, 16, true)
			--sprites
			end
		end
	end
	if not Level.usebackground then
		layer.map:blit(0, 0, images.level_border, 0, 0, images.level_border:width(), images.level_border:height(), true)
	end
end	


function drawStats()
		screen:blit(2,2, images.gfx_p1, 0, 0, 16, 12, true)
		screen:print(25,4,'D:'..player.p1.deaths..' S:'..player.p1.suicide..' K:'..player.p1.kills,Color.new(255,0,0))

		screen:blit(462,2, images.gfx_p2, 0, 0, 16, 12, true)
		screen:print(370,4,'D:'..player.p2.deaths..' S:'..player.p2.suicide..' K:'..player.p2.kills,Color.new(255,0,0))

end


function drawSprites()
	drawBombs()
	drawBreakingWall()
end


function drawBreakingWall()
	for i=0,table.getn(Level.data)-1 do --15 tiles
		for j=0,table.getn(Level.data[1])-1 do --17 tiles
			if Level.data[i+1][j+1] >= 100 then--wall-breaking
				curframe=Level.data[i+1][j+1]
				--8frames!
				layer.backpuffer:blit(Level.x+i*16, Level.y+j*16, images.gfx_tiles, tile.breakingWall.x+math.mod(curframe,10)*16, tile.breakingWall.y, 16, 16, true)
				--print('wall is breaking:'..tile.breakingWall.x+math.mod(curframe,10)*16)
				if curframe<108 then
					Level.data[i+1][j+1]=curframe+1
				else
					Level.data[i+1][j+1]=0 --its an empty block now
				end
			end
		end
	end
end


function drawPlayers()
	--blit player 1
	if player.p1.move and player.p1.visible then
		layer.backpuffer:blit(player.p1.x, Level.y+player.p1.y, images.gfx_p1, tile_p1[player.p1.direction].x+math.mod(framecount,tile_p1[player.p1.direction].cycle)*16, tile_p1[player.p1.direction].y, 16, 24, true)
	elseif player.p1.visible then --show it standing
		layer.backpuffer:blit(player.p1.x, Level.y+player.p1.y, images.gfx_p1, tile_p1[player.p1.direction].x, tile_p1[player.p1.direction].y, 16, 24, true)
	end
	
	--blit player 2
	if not singleplayer then
		if player.p2.move and player.p2.visible then
			layer.backpuffer:blit(player.p2.x, Level.y+player.p2.y, images.gfx_p2, tile_p2[player.p2.direction].x+math.mod(framecount,tile_p2[player.p2.direction].cycle)*16, tile_p2[player.p2.direction].y, 16, 24, true)
		elseif player.p2.visible then --show it standing
			layer.backpuffer:blit(player.p2.x, Level.y+player.p2.y, images.gfx_p2, tile_p2[player.p2.direction].x, tile_p2[player.p2.direction].y, 16, 24, true)
		end
	end
end

function getBombCount(local_player)
	count=0
	for i=1,10 do
		--if player.p1.bombs[i].active or player.p1.bombs[i].placed then
		if local_player.bombs[i].placed then
			count=count+1
		end
	end
	return count
end


function playerDropBomb(local_player)
	--layer.explode:clear() -- clear the layer to keep it clean
	--try to drop a bomb
	--first check if we are allowed to drop!
	bombx=local_player.tilex
	bomby=local_player.tiley
	addednewbomb = false
	if (local_player.hasbombs > getBombCount(local_player)) and (Level.data[bombx][bomby]==0) then -- player has more bombs than already on field
		snd_laybomb:play()
		--try to find a bomb that is not placed
		for i=1,local_player.hasbombs do
			if (not local_player.bombs[i].placed) and (not addednewbomb) then --and (not local_player.bombs[i].active) and (not addednewbomb) then
				
				Level.data[bombx][bomby] = 11
				local_player.bombs[i].x = bombx
				local_player.bombs[i].y = bomby
				local_player.bombs[i].placed=true			
				local_player.bombs[i].frame=0
				addednewbomb=true
				--print('bomb dropped')
			end
		end
	end
end


function drawBombs()
	layer.explode:clear()
	for i=1,10 do
		if player.p1.bombs[i].placed then
			player.p1.bombs[i].time=player.p1.bombs[i].time-1	
		end
	 	--bomb is counting down
		if player.p1.bombs[i].placed and player.p1.bombs[i].time>0 then --and not player.p1.bombs[i].active then
			--draw the bomb
			layer.backpuffer:blit(Level.x+player.p1.bombs[i].x*16-16, Level.y+player.p1.bombs[i].y*16-16, images.gfx_bombs, tile.bomb.x+math.mod(framecount,tile.bomb.cycle)*16, tile.bomb.y, 16, 16, true)
			
		--the bomb is aready exploding
		elseif player.p1.bombs[i].time<=0 then -- or player.p1.bombs[i].active
			if Level.data[player.p1.bombs[i].x][player.p1.bombs[i].y]~=-1 then
				Level.data[player.p1.bombs[i].x][player.p1.bombs[i].y]=-1 --set it to KILL
				--print('set to kill')
			end
			--draw the explosion where the bomb was!
			explode(player.p1.bombs[i].x,player.p1.bombs[i].y,player.p1.bombs[i].frame)
			player.p1.bombs[i].frame=player.p1.bombs[i].frame+1
			
			if player.p1.bombs[i].time==0 then -- play sound only once!
				snd_explode:play() --play the boom sound
			end
			flame(player.p1,i,0,-1) --up!
			flame(player.p1,i,0,1) --down!
			flame(player.p1,i,-1,0) --left!
			flame(player.p1,i,1,0) --right!
			
			--check till -9 cause if its -8 we set the tile to harmless
			if player.p1.bombs[i].time<-9 then --its over reset the bomb
				--print('entschrft')
				Level.data[player.p1.bombs[i].x][player.p1.bombs[i].y]=0
				resetBomb(i, player.p1)
			end
		end
	end
	if not singleplayer then
		for i=1,10 do
			if player.p2.bombs[i].placed then
				player.p2.bombs[i].time=player.p2.bombs[i].time-1	
			end
		 	--bomb is counting down
			if player.p2.bombs[i].placed and player.p2.bombs[i].time>0 then --and not player.p1.bombs[i].active then
				--draw the bomb
				layer.backpuffer:blit(Level.x+player.p2.bombs[i].x*16-16, Level.y+player.p2.bombs[i].y*16-16, images.gfx_bombs, tile.bomb.x+math.mod(framecount,tile.bomb.cycle)*16, tile.bomb.y, 16, 16, true)
				
			--the bomb is aready exploding
			elseif player.p2.bombs[i].time<=0 then -- or player.p2.bombs[i].active
				if Level.data[player.p2.bombs[i].x][player.p2.bombs[i].y]~=-2 then
					Level.data[player.p2.bombs[i].x][player.p2.bombs[i].y]=-2 --set it to KILL
					--print('set to kill')
				end
				--draw the explosion where the bomb was!
				explode(player.p2.bombs[i].x,player.p2.bombs[i].y,player.p2.bombs[i].frame)
				player.p2.bombs[i].frame=player.p2.bombs[i].frame+1
				
				if player.p2.bombs[i].time==0 then -- play sound only once!
					snd_explode:play() --play the boom sound
				end
				flame(player.p2,i,0,-1) --up!
				flame(player.p2,i,0,1) --down!
				flame(player.p2,i,-1,0) --left!
				flame(player.p2,i,1,0) --right!
				
				--check till -9 cause if its -8 we set the tile to harmless
				if player.p2.bombs[i].time<-9 then --its over reset the bomb
					--print('entschrft')
					Level.data[player.p2.bombs[i].x][player.p2.bombs[i].y]=0
					resetBomb(i, player.p2)
				end
			end
		end	
	end
end


function resetBomb(i, local_player)
--	player.p1.bombs[i].active=false
	local_player.bombs[i].placed=false
	local_player.bombs[i].time=60
	local_player.bombs[i].frame=0
	local_player.bombs[i].x = 0
	local_player.bombs[i].y = 0
end

function flame(local_player,i,x,y)
--print('time='..player.p1.bombs[i].time)
--item-IDS_
--0 = empty
--1 = solid
--2 = bombable
--11 = p1-bomb
--12 = p2-bomb
	
	for flame=1,local_player.flamelength-1 do
		--out of field?
		if local_player.bombs[i].x+flame*x >= table.getn(Level.data)+1 or
			 local_player.bombs[i].x+flame*x <= 0  or
			 local_player.bombs[i].y+flame*y >= table.getn(Level.data[1])+1 or
			 local_player.bombs[i].y+flame*y <= 0 then
			 break
			 --return
		end
		--flame hits empty
		if Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] <= 0 then
			--print('hit empty')
			--draw the explosion above, below, left and right, depends on the input
			if local_player.bombs[i].time>-8 then
				if local_player==player.p1 then
					Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y]=-1
				elseif local_player==player.p2 then
					Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y]=-2
				end
				explode(local_player.bombs[i].x+flame*x,local_player.bombs[i].y+flame*y,local_player.bombs[i].frame )
			else
				Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y]=0
			end
			
			
		--flame hits a bomb of player
		elseif Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] == 11 or
					 Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] == 12 then
			--print('BOMB')
			donateBombAt(local_player.bombs[i].x+flame*x,local_player.bombs[i].y+flame*y)
			--donateBombAt(player.p1.bombs[i].x,player.p1.bombs[i].y+flame*y)
			
			
		--flame hits solid
		elseif Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] == 1 or
					 Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] >= 100 then --breaking wall = 100..108
			--print('solid')
			break
			
			
		--flame hits bombable and wer are NOT at time -9 (would be the time to set back the block)
		elseif (Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] == 2) and (local_player.bombs[i].time > -8) then
			--print('bombable-wall@'..player.p1.bombs[i].x+flame*x..'|'..player.p1.bombs[i].y+flame*y)
			Level.data[local_player.bombs[i].x+flame*x][local_player.bombs[i].y+flame*y] = 100
			break
		end
	end
end


function donateBombAt(x,y)
--print('bomb at: '..x..'...'..y)
	for i=1,10 do
		--print(player.p1.bombs[i].x..'|'..player.p1.bombs[i].y)
		if player.p1.bombs[i].x == x and player.p1.bombs[i].y == y then
			player.p1.bombs[i].placed=true
			player.p1.bombs[i].time=0
			break --> exit loop&function
		end
	end
end


function explode(x,y,framenumber)
	posx = x*16-16+Level.x --104-16
	posy = y*16-16+Level.y ---16+8 (center of the tile)
	layer.explode:blit(posx, posy, images.gfx_bombs, framenumber*16-16,tile.bombexplode.y,16,16, true)
end


function newGame()
	layer.map:clear()
	updatePlayers()
	drawMap()
	score = 0
end

function keyboardControl()
	screen.waitVblankStart()
	pad = Controls.read()
	updatePlayerTiles() --update the player position
	p1_moves = false
	p2_moves = false
	
	if pad:up() then
		if canMove(player.p1, up) then
			movement.p1.dx = 0
			movement.p1.dy = -1
			p1_moves=true
			--was the last direction something else?
			if player.p1.lastdirection ~= up then --yes was different
				player.p1.lastdirection = up
				player.p1.direction = up
				movement.p1.speedy = player.p1.speed
				movement.p1.speedx = 0
			end
		end
	elseif pad:down() then
		if canMove(player.p1, down) then
			movement.p1.dx = 0
			movement.p1.dy = 1
			p1_moves=true
			if player.p1.lastdirection ~= down then --yes was different
				player.p1.lastdirection = down
				player.p1.direction = down
				movement.p1.speedy = player.p1.speed
				movement.p1.speedx = 0
			end
		end
	elseif pad:left() then
		if canMove(player.p1, left) then
			movement.p1.dx = -1
			movement.p1.dy = 0
			p1_moves=true
			if player.p1.lastdirection ~= left then --yes was different
				player.p1.lastdirection = left
				player.p1.direction = left
				movement.p1.speedy = 0
				movement.p1.speedx = player.p1.speed
			end
		end
	elseif pad:right() then
		if canMove(player.p1, right) then
			movement.p1.dx = 1
			movement.p1.dy = 0
			p1_moves=true
			if player.p1.lastdirection ~= right then --yes was different
				player.p1.lastdirection = right
				player.p1.direction = right
				movement.p1.speedy = 0
				movement.p1.speedx = player.p1.speed
			end
		end
	end
	
	if singleplayer then
		if pad:cross() then -- p1 lay bomb
			--lay bomb code here
			playerDropBomb(player.p1)
		end
		if pad:triangle() then
			screen:save("screenshot.tga")
		end
	-- MULTIPLAY
	else -- 2-player-game
		--player 1 lay bomb:
		if pad:l() then -- p1 lay bomb
			--drop bomb code here
			playerDropBomb(player.p1)
		end
		if pad:triangle() then
			if canMove(player.p2, up) then
				movement.p2.dx = 0
				movement.p2.dy = -1
				p2_moves=true
				--was the last direction something else?
				if player.p2.lastdirection ~= up then --yes was different
					player.p2.lastdirection = up
					player.p2.direction = up
					movement.p2.speedy = player.p2.speed
					movement.p2.speedx = 0
				end
			end
		elseif pad:cross() then
			if canMove(player.p2, down) then
				movement.p2.dx = 0
				movement.p2.dy = 1
				p2_moves=true
				if player.p2.lastdirection ~= down then --yes was different
					player.p2.lastdirection = down
					player.p2.direction = down
					movement.p2.speedy = player.p2.speed
					movement.p2.speedx = 0
				end
			end
		elseif pad:square() then
			if canMove(player.p2, left) then
				movement.p2.dx = -1
				movement.p2.dy = 0
				p2_moves=true
				if player.p2.lastdirection ~= left then --yes was different
					player.p2.lastdirection = left
					player.p2.direction = left
					movement.p2.speedy = 0
					movement.p2.speedx = player.p2.speed
				end
			end
		elseif pad:circle() then
			if canMove(player.p2, right) then
				movement.p2.dx = 1
				movement.p2.dy = 0
				p2_moves=true
				if player.p2.lastdirection ~= right then --yes was different
					player.p2.lastdirection = right
					player.p2.direction = right
					movement.p2.speedy = 0
					movement.p2.speedx = player.p2.speed
				end
			end
		end
		--player 2 lay bomb:
		if pad:r() then -- p1 lay bomb
			--drop bomb code here
			playerDropBomb(player.p2)
		end	
	end

	--always do this:
	if p1_moves then -- only if a key is pressed move the little bastard
		player.p1.move=true
	else
		player.p1.move=false
	end
	if p2_moves then -- only if a key is pressed move the little bastard
		player.p2.move=true
	else
		player.p2.move=false
	end	
	move()
end


function move()
	if player.p1.move then
		--check if the current tile is blowing up
		--move player1 to x and y
		player.p1.x = player.p1.x+movement.p1.dx*movement.p1.speedx
		player.p1.y = player.p1.y+movement.p1.dy*movement.p1.speedy
		updatePlayers()
	end
	if not singleplayer then
		if player.p2.move then
			--check if the current tile is blowing up
			--move player1 to x and y
			player.p2.x = player.p2.x+movement.p2.dx*movement.p2.speedx
			player.p2.y = player.p2.y+movement.p2.dy*movement.p2.speedy
			updatePlayers()
		end	
	end
end


function death(local_player, killer)
	if not local_player.undestroyable then
		if local_player == player.p1 then
			local_player.tilex = Startpos.p1.x
			local_player.tiley = Startpos.p1.x
			local_player.posx = Level.x+Startpos.p1.x*16-16
			local_player.posy = -14+Startpos.p1.x*16-16
			local_player.x = Level.x+Startpos.p1.x*16-16
			local_player.y = -14+Startpos.p1.y*16-16
		else -- its player 2	
			local_player.tilex = Startpos.p2.x
			local_player.tiley = Startpos.p2.x
			local_player.posx = Level.x+Startpos.p2.x*16-16
			local_player.posy = -14+Startpos.p2.x*16-16
			local_player.x = Level.x+Startpos.p2.x*16-16
			local_player.y = -14+Startpos.p2.y*16-16	
		end
		local_player.visible=false
		local_player.undestroyable=true
		local_player.freeze = 30 --freeze a sec
		local_player.deaths=local_player.deaths+1
		if local_player==killer then
			--always true
			local_player.suicide=local_player.suicide+1
		else
			killer.kills=killer.kills+1
		end
		updatePlayers()
	end
end

function updatePlayers()
	--update position
	player.p1.posx = player.p1.x+8-Level.x
	player.p1.posy = player.p1.y+21
	--ok?
	if not singleplayer then
		player.p2.posx = player.p2.x+8-Level.x
		player.p2.posy = player.p2.y+21	
	end
end

function canMove(local_player, direction)
	if local_player.freeze>0 then
		return false
	end
-- out of borders??
		--OK
		if local_player.tiley-1<=0 and direction==up then
			if local_player.y>=8-Level.y then
				return true
			else
				return false
			end
		end
		--OK
		if local_player.tilex-1<=0 and direction==left then
			if local_player.x>=Level.x then
				return true
			else
				return false
			end
		end
		--bug
		if local_player.tilex+1>=table.getn(Level.data) and direction==right then
			if local_player.x<=(Level.x+448) then --16*28 then
				return true
			else
				return false
			end
		end
		--bug
		if local_player.tiley+1>=table.getn(Level.data[1]) and direction==down then
			--print(table.getn(Level.data[1]))
			--print(player.p1.y)
			if local_player.y<=Level.y+190 then --level.y=24
		 		return true
			else
				return false
			end
		end	

--check the distance between two points...
-- x1,y1 & x2,y2
--if dx = (x2 - x1) and dy = (y2 - y1) then
--distance = square root of ( dx * dx + dy * dy )
--This assumes x1,y1 is the centre of bomberman

--check 2 points for collision (of ONE tile) <-- SIMPLYFIED, was 4 once!
--x;x+16,y;y+16

--set bombermans center:
	x1=local_player.posx
	y1=local_player.posy
	x2=local_player.tilex
	y2=local_player.tiley
	
		--check the 2 points
		if collide(x1,y1,x2,y2,1,direction) or collide(x1,y1,x2,y2,2,direction) then
			return false
		else
			return true			
		end	
end

function collide(x1,y1,x2,y2,point,dir)
	--print(player.p2.tilex+check_tiles[dir][1])
	--print(player.p2.tiley+check_tiles[dir][2])
	-- 0 = empty; -1 = KILL
	--print(x2+check_tiles[dir][1])
	--print(y2+check_tiles[dir][2])
	-- next lines are a BUGFIX!
	if Level.data[x2+check_tiles[dir][1]][y2+check_tiles[dir][2]]==nil then 
		return false
	elseif Level.data[x2+check_tiles[dir][1]][y2+check_tiles[dir][2]] > 0 then
		-- there is a solid floor! --return true
		x2=x2*16-16+check_coordinates[dir][point][1] 
		y2=y2*16-16+check_coordinates[dir][point][2]
		dx=(x2 - x1)
		dy=(y2 - y1)
		dist = math.sqrt( dx*dx + dy*dy )	
		if dist<9 then --worked fine with 10 --with 9 you can walk though ONE FUCKING BLOCK
			--print('collide')		
			return true
		else
			--print('free to walk')
			return false
		end
	end
	return false
end


function saveHighscore()
	file = io.open(highscoreFile, "w")
	if file then
		file:write(high)
		file:close()
	end
end

function loadHighscore()
	file = io.open(highscoreFile, "r")
	if file then
		high = file:read("*n")
		file:close()
	end
end

--get the tile# where the player is standing
function updatePlayerTiles()
	--get the standing tile for player 1
	player.p1.tilex = math.floor((player.p1.posx) / 16) +1
	player.p1.tiley = math.floor((player.p1.posy) / 16) +1
	--same for player 2
	player.p2.tilex = math.floor((player.p2.posx) / 16) +1
	player.p2.tiley = math.floor((player.p2.posy) / 16) +1
	
	--screen:print(0,0,math.floor((player.p1.x-Level.x) / 16),Color.new(255,0,0))
	--screen:print(0,10,math.floor(player.p1.y / 16),Color.new(0,255,0))
end

function checkPlayers()
	--always check if he gets killed!
	--print('VALUE AT PLAYER 1 -->'..Level.data[player.p1.tilex][player.p1.tiley])
	--print('VALUE AT PLAYER 2 -->'..Level.data[player.p2.tilex][player.p2.tiley])
	if Level.data[player.p1.tilex][player.p1.tiley] == -1 then
		death(player.p1, player.p1)
		--player.p1.suicide=player.p1.suicide+1
	elseif Level.data[player.p1.tilex][player.p1.tiley] == -2 then
		death(player.p1,player.p2)
		--player.p2.kills=player.p2.kills+1
	end
	
	if Level.data[player.p2.tilex][player.p2.tiley] == -2 then
		death(player.p2,player.p2)
		--player.p2.suicide=player.p2.suicide+1
	elseif Level.data[player.p2.tilex][player.p2.tiley] == -1 then
		death(player.p2,player.p1)
		--player.p1.kills=player.p1.kills+1
	end	
end

function defreeze()
	if player.p1.freeze>0 then
		player.p1.freeze=player.p1.freeze-1
	elseif player.p1.freeze==0 and player.p1.visible==false then
		player.p1.visible=true
		player.p1.undestroyable=false
	end
	if not singleplayer then
		if player.p2.freeze>0 then
			player.p2.freeze=player.p2.freeze-1
		elseif player.p2.freeze==0 and player.p2.visible==false then
			player.p2.visible=true
			player.p2.undestroyable=false
		end
	end
end

function initMovement()
	for all in player do
		movement[all].speedx = player[all].speed
		movement[all].speedy = player[all].speed
	end
end


function checkGameType()
--GameType = {
--	Time = {title='Time', time=2, value=0 }, --in minutes
--	Points = {title='Points', time=0, value=10},
--	Kills = {title='Kills', time=0, value=10}
--}
	local p1_points, p2_points
	p1_points = player.p1.kills-player.p1.suicide
	p2_points = player.p2.kills-player.p2.suicide
		
	if LEVEL_TYPE == GameType.TimePoints.title then
		if (playtime/1000)> GameType.Time.time then
			if p1_points > p2_points then
				gameOver = 'Player 1 Wins!'
			elseif p2_points > p1_points then
				gameOver = 'Player 2 Wins!'
			else
				gameOver = 'Draw'
			end
		end
	elseif LEVEL_TYPE == GameType.TimeKills.title then
		if (playtime/1000)> GameType.Time.time then
			if player.p1.kills > player.p2.kills then
				gameOver = 'Player 1 Wins!'
			elseif player.p2.kills > player.p1.kills then
				gameOver = 'Player 2 Wins!'
			else
				gameOver = 'Draw'
			end
		end
	elseif LEVEL_TYPE == GameType.Points.title then
		if p1_points >= GameType.Points.value or
		   p2_points >= GameType.Points.value then
			if p1_points > p2_points then
				gameOver = 'Player 1 Wins!'
			elseif p2_points > p1_points then
				gameOver = 'Player 2 Wins!'
			else
				gameOver = 'Draw'
			end
		end
	elseif LEVEL_TYPE == GameType.Kills.title then
		if player.p1.kills >= GameType.Kills.value or
			 player.p2.kills >= GameType.Kills.value then
			if player.p1.kills > player.p2.kills then
				gameOver = 'Player 1 Wins!'
			elseif player.p2.kills > player.p1.kills then
				gameOver = 'Player 2 Wins!'
			else
				gameOver = 'Draw'
			end
		end	
	end
end




--#########################################--
--loadHighscore()
--loadedHighscore = high
math.randomseed(os.difftime()) --new in v .10

--temp
--player.p1.bombs[1].placed=true
--player1DropBomb(7, 7)
--player1DropBomb(6, 7)
--player1DropBomb(5, 7)
--following line can be removed, when levelload is completed
Level.data = transposeMatrix(Level.data)

--playtime = Timer.new(0) -- ms!
--playtime:start()
initMovement()
--newGame()


--game loop
while gameOver=='false' do
	--increase the framecount but keep it between 1 and 8
	framecount = math.mod(framecount, 8)+1
	keyboardControl()
	drawMap()
	if Level.usebackground then
		layer.backpuffer:blit(0, 0, layer.background, 0, 0, layer.background:width(), layer.background:height(), false)
		layer.backpuffer:blit(0, 0, layer.map, 0, 0, layer.map:width(), layer.map:height(), true) --set to true if there is a good bG
	else
		layer.backpuffer:blit(0, 0, layer.map, 0, 0, layer.map:width(), layer.map:height(), false) --set to true if there is a good bG
	end
	drawSprites();
	layer.backpuffer:blit(0, 0, layer.explode, 0, 0, layer.explode:width(), layer.explode:height(), true)
	drawPlayers() -- draws to backpuffer
	checkPlayers()
	screen:blit(0, 0, layer.backpuffer, 0, 0, layer.backpuffer:width(), layer.backpuffer:height(), false)
	drawStats()
	if score > high then
		high = score
	end
	defreeze()
	screen.waitVblankStart(2) -- set framerate to 30fps
	screen.flip()
	checkGameType()
end
--playtime:stop()
dofile("./winner.lua")
--playtime:reset()