--[[
===================================================
this file is a sample Level for Bomberman by Lumo
===================================================
]]
--name = 'ZeroBlocks' -- this is the name of your Level
--http://www.lua.org/pil/21.2.html

--[[
stuff that is needed to create a full scheme file:
version number
	-V,#
name of the Level
	-N,name
actual data array 17x17
	-D
player start (dunno how many guess 1|2)
	-S
sprites you start with
	-P,ID,value
graphic of the Level
	-G, name
]]

--Level = {
	--name='',
--	version=0,
--	data={},
--	playerstart={},
--	sprites={}
--}
--Startpos = {p1={x=0,y=0},p2={x=0,y=0}}

function fileexists(filename)
	file = io.open(filename, "r")
	io.close() -- cleanup
  return file
end

function echoMatrix(matrix)
	for i=1,table.getn(matrix) do
		out='|'
		for j=1,table.getn(matrix[i]) do
			out=out..matrix[j][i]..'|'
		end
		print(out)--print out a line
	end
end

function transposeMatrix(matrix)
	newMatrix = {}
	for i = 1,table.getn(matrix) do  --1..17
		table.insert( newMatrix, {} ) --adds a line
		for j = 1,table.getn(matrix[i]) do	--1..17
			table.insert( newMatrix[i], matrix[j][i] ) --change i|j
		end
	end
	return newMatrix
end

function stripChar(text)
	return string.sub(text, 2)
end

function strip2Char(text)
	return string.sub(text, 3)
end

function getChar(text)
	return string.sub(text, 1, 1)
end

function str_explode(text, needle)
	local array={}
	_, count = string.gsub(text, needle, needle)
	for index=1,count+1 do
		i, j = string.find(text, needle)
		if i == nil or j==nil then
			i=0
			j=0
		end
	  table.insert(array,string.sub(text, 1, i-1))
		text=string.sub(text, j+1 )
  end
  return array
end

function str_implode(array, needle)
	local str = ''
	for i=1,table.getn(array)-1 do
		str = str..array[i]..needle
	end
	str = str..array[table.getn(array)]
	return str
end

function string2array(inputstring)
	array = {}
	length=string.len(inputstring)
	for i=1,length do
		table.insert(array, string.sub(inputstring, i, i))
	end
	return array
end

function loadLevel(filename)
	local Levelsch = assert(io.open(filename, "r"))
	local lines = {}
	newline=Levelsch:read("*line")
	while newline ~= nil do -- read the lines in table 'lines'
		-- only parse interesting lines
		-- identify em with the first char '-'
		identifyer = string.sub(newline, 1, 1)
		if identifyer == '-' then
			line=stripChar(newline)
			type=string.sub(line, 1, 1)
			
			if type == 'N' then --its the name
				--Level.name=strip2Char(line) no more needed, use filename
				
			elseif type == 'V' then --its the version
				Level.version=strip2Char(line)
				
			elseif type == 'S' then --its the startpoints
				print('line= '..strip2Char(line))
				tmp=str_explode(strip2Char(line), ',')
				if tmp[1] == '1' then --player1
					Startpos.p1.x=tmp[2]
					Startpos.p1.y=tmp[3]
					print('1= '..tmp[1])
					print('2= '..tmp[2])
					print('3= '..tmp[3])
				else
					Startpos.p2.x=tmp[2]
					Startpos.p2.y=tmp[3]					
				end
						
				
			elseif type == 'P' then --its the Powerups
			--bit to do here
			
			elseif type == 'G' then --its the Graphic
				if fileexists(strip2Char(line)..'.png') then
					Level.style=strip2Char(line)..'.png'
				else
					Level.style='gfx_park_tiles.png'
				end
					
			elseif type == 'B' then --its the Background
				if strip2Char(line)=='false' then
					Level.usebackground=false
					Level.background=''
				else
					if fileexists(strip2Char(line)..'.png') then
						Level.usebackground=true
						Level.background=strip2Char(line)..'.png'	
					else
						Level.usebackground=false
						Level.background=''
					end
				end
			elseif type == 'D' then --its the datagrid
			--lot to do here!
			--replace to ingame stuff
			 line=strip2Char(line)
			 line = string.gsub(line, ':', '2')
			 line = string.gsub(line, "#", "1")
			 line = string.gsub(line, "_", "0")
			 table.insert(Level.data,string2array(line,','))
			end
			--print(line)
			--table.insert(lines, line)
		else
			--skip
		end
		newline=Levelsch:read("*line")
	end
end

print(selectedScheme)
loadLevel(selectedScheme)
--Level.data=transposeMatrix(Level.data) --needs to be done...
--print('the name of your Level is: '..Level.name)
--print('the version of your Level is: '..Level.version)
--print('the datamatrix of your Level is: ')
--echoMatrix(Level.data)

--note, playerstarts and sprites need to be done
