-- barheight = 184 (dragger-height min = 24) --> 160 left
--height = 184/(count -showcount) = here: 184/(25-20)

layer = {
	background= Image.load('schemebrowser.png'),
	backpuffer = Image.createEmpty(480, 272)
	}

colors = {
	black = Color.new(0,0,0),
	darkblue = Color.new(0,72,95),
	white = Color.new(255,255,255)
}

function listSchemes()
	--print('contents')
	contents = System.listDirectory()
	--print('cwd')
	cwd = System.currentDirectory()
	
	table.sort(contents, function (a, b) return a.name < b.name end)

	done = false
	--print(',')
	while not done do -- filter out unwanted files
		for index,file in contents do
			if not string.find(file.name, ".sch") then --its a scheme file
				table.remove(contents, index)
				break
			end
			if index == table.getn(contents) then
				done = true
			end
			--print('.')
		end
	end

	for index, file in contents do
		-- defaults
		file.icon = nil
		file.render = nil
		file.ftype = "none"

		print(file)
	end -- loop through dir()
	return contents
end -- function call


function renderView(files)
	layer.backpuffer:clear()
	renderindex=0
	for index in files do
		renderindex=renderindex+1
		--print('render_start '..render_start)
		--print('render_end '..render_end)
		if index >= render_start and index < render_end then
			if selected == index then
				layer.backpuffer:drawLine(19, 40+(index-render_start+1)*10, 471, 40+(index-render_start+1)*10, colors.black) 
				layer.backpuffer:fillRect(19, 41+(index-render_start+1)*10, 454, 8, colors.darkblue) 
				layer.backpuffer:drawLine(19, 41+(index-render_start+1)*10+8, 471, 41+(index-render_start+1)*10+8, colors.black) 
			 	layer.backpuffer:print(22,41+(index-render_start+1)*10, files[index], colors.white )
			--draw the dragbar
			--black border
			--layer.backpuffer:drawLine(9, 41+(index-render_start+1)*10, 19, 41+(index-render_start+1)*10, colors.black) 
			--layer.backpuffer:drawLine(9, 41+(index-render_start+1)*10+8, 19, 41+(index-render_start+1)*10+8, colors.black) 			 	
			else
			  layer.backpuffer:print(22,41+(index-render_start+1)*10, files[index], colors.darkblue )
			end --color select
		end --in drawregion?
		--draw schemecount
		layer.backpuffer:print(22,253, 'There are currently '..table.getn(files)..' Scheme Files available.', colors.black )
		
	end --end for
end


selectedScheme = 'basic.sch'

function controls()
	pad = Controls.read()
	if pad ~= oldPad then
	  if pad:circle() or pad:start() then --select the current point
	  	selectedScheme = files[selected]
	  	dofile('./loadlevel.lua')
		end
    if pad:up() then
	    selected = selected - 1
	    if selected <= 0 then
	    	selected = 1
	    end
	  end
	  if pad:down() then
	    selected = selected + 1
	    if selected > table.getn(files) then
	    	selected = table.getn(files)
	    end
	  end
	  oldPad = pad
	end

	if selected >= render_end then
		render_start=render_start+1
	end
	if selected < render_start then
		render_start=render_start-1
	end	
	render_end=render_start+rendercount
end


selected=1
rendercount = 20 --number of displayed maps

render_start=1
render_end=render_start+rendercount
while not Controls.read():start() do
	screen:clear()
	--print('listSchemes()')
	--files = listSchemes()
	files = {'eins', 'zwei', 'basic.sch', 'vier', 'fuenf', 'sechs', 'sieben', 'acht', 'neun', 'zehn', 'elf', 'zwoelf', 'dreizehn', 'vierzehn', 'fuenfzehn', 'sechzehn', 'siebzehn', 'achtzehn', 'neunzehn', 'zwanzig', 'einundzwanzig', 'zweiundzwanzig', 'dreiundzwanzig', 'vierundzwanzig', 'fuenfundzwanzig'}
	controls()
	renderView(files)
	screen:blit(0,0,layer.background, 0,0, layer.background:width(), layer.background:height(), false)
	screen:blit(0,0,layer.backpuffer, 0,0, layer.backpuffer:width(), layer.backpuffer:height(), true)
	screen.waitVblankStart()
	screen.flip()
end

--add explorer style! should not be that hard...