--load sound
snd_bomberman = Sound.load('splash-bm.wav', false) --do not loop
snd_splash = Sound.load('splash-bomb.wav')

--load images
img_splash = Image.load("title.png")
gfx = Image.load("gfx_bombs.png") --192x16
--bombs are 0


layer = {
	splash = Image.createEmpty(480, 272),
	explode = Image.createEmpty(480, 272)
}
splashframe = 0
time=0
splashbombs={
	{x=0,y=168,frame=0,cury=1,dir=1, height=2.50, speed=3},
	{x=34,y=250,frame=0,cury=1,dir=1, height=1.70, speed=4},
	{x=50,y=150,frame=0,cury=1,dir=1, height=1.00, speed=2},
	{x=80,y=186,frame=0,cury=1,dir=1, height=3.50, speed=7},
	{x=110,y=89,frame=0,cury=1,dir=1, height=2.50, speed=5},
	{x=30,y=100,frame=0,cury=1,dir=2, height=3.50, speed=6},
	{x=74,y=145,frame=0,cury=1,dir=2, height=2.20, speed=3},
	{x=125,y=130,frame=0,cury=1,dir=2, height=1.50, speed=5},
	{x=157,y=270,frame=0,cury=1,dir=2, height=1.50, speed=8},
	{x=173,y=199,frame=0,cury=1,dir=2, height=1.20, speed=4},
	}
explosions = {}

function freeResources()
	snd_splash = nil
	snd_bomberman=nil
	img_splash=nil
	gfx=nil
	explosions=nil
	splashframe = nil
	splashbombs = nil
	layer.splash=nil
	layer.explode=nil
	layer=nil
	time=nil
end

function splashexplode(x,y,framenumber)
	posx = x-8
	posy = y-8
	layer.explode:blit(posx,posy, gfx, framenumber*16-16,16,16,16, true)
end


function throwbombin(i,dir)
	if splashbombs[i].cury <0 then
		yvalue = math.sin(splashbombs[i].cury)*50
	else
		yvalue = 1-math.sin(splashbombs[i].cury)*50
	end
	--print(yvalue)
	if dir~=1 then
		layer.splash:blit(480-splashbombs[i].x,splashbombs[i].y+yvalue*splashbombs[i].height,gfx, 16*splashframe,0,16,16, true ) --draw 
--		splashbombs[i].x=480-splashbombs[i].x
	else
		layer.splash:blit(splashbombs[i].x,splashbombs[i].y+yvalue*splashbombs[i].height,gfx, 16*splashframe,0,16,16, true ) --draw 
	end
end

math.randomseed(os.difftime()) --new in v .10

function randombomb(i)
	splashbombs[i].x=0
	splashbombs[i].y=math.random(120,272)
	splashbombs[i].frame=0
	splashbombs[i].cury=1
	splashbombs[i].dir=math.random(1,2)
	splashbombs[i].height=math.random(1,3)
	splashbombs[i].speed=math.random(3,8)
end

-- 5 Sec Splash sccreen (that must university be worth)
while (time<17*30 and (not Controls.read():start())) do  --17*30 frames = 17 secs
	if time == 90 then
		snd_bomberman:play()  -- shout out bomberman!
	end
	layer.splash:clear()
	layer.explode:clear()
	screen:clear()
	for i=1,10 do
		splashbombs[i].x=splashbombs[i].x+splashbombs[i].speed
		if splashbombs[i].x > 480 then
			randombomb(i)
		end
		splashbombs[i].cury=splashbombs[i].cury-.1
		if splashbombs[i].cury < -1 then
			splashbombs[i].cury = 1
		end
		if math.random(0,100) == 50 then  --just a number 1:100
				if splashbombs[i].cury <0 then
					tmpyvalue = math.sin(splashbombs[i].cury)*50
				else
					tmpyvalue = 1-math.sin(splashbombs[i].cury)*50
				end
				tmpyvalue = splashbombs[i].y+tmpyvalue*splashbombs[i].height
			table.insert(explosions, {x=splashbombs[i].x,y=tmpyvalue,frame=0})
			snd_splash:play() --1..lenght of array
			randombomb(i)	--send in a new bomb
		end
		throwbombin(i,splashbombs[i].dir)
	end
	
	for explo in explosions do
		explosions[explo].frame=explosions[explo].frame+1
		if explosions[explo].frame >8 then --remove from table
			table.remove(explosions,explo)
		else
			--print(explosions[explo].x)
			splashexplode(explosions[explo].x,explosions[explo].y,explosions[explo].frame)
		end
	end
	
	screen:blit(144, 20, img_splash, 0, 0, img_splash:width(), img_splash:height(), true)
	screen:blit(0,0,layer.explode, 0, 0, layer.explode:width(), layer.explode:height(), true)
	screen:blit(0,0,layer.splash, 0, 0, layer.splash:width(), layer.splash:height(), true)
	screen.flip()
	screen.waitVblankStart(2)
	time=time+1
	splashframe = math.mod(splashframe+1,8)
end
--cleanup
freeResources()